diff --git a/Client/Client/Assets/Scripts/Weather/Parser/ValueToConditions.cs b/Client/Client/Assets/Scripts/Weather/Parser/ValueToConditions.cs
new file mode 100644
index 0000000..09c0813
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/ValueToConditions.cs
@@ -0,0 +1,74 @@
+﻿//
+// Author: A. Konig
+//
+
+namespace ServerApp.Parser.OutputInfo
+{
+    /// <summary>
+    /// Transfers various values to weather conditions and vice versa
+    /// </summary>
+    /// <author>A. Konig</author>
+    public static class ValueToConditions
+    {
+        /// <summary>
+        /// Lux to weather conditions
+        /// </summary>
+        /// <param name="lux">Lux value</param>
+        /// <returns>Weather conditions</returns>
+        public static WeatherConditions TransferLuxToConditions(double lux)
+        {
+            if (lux > 40_000)
+                return WeatherConditions.Sunny;
+
+            if (lux > 20_000)
+                return WeatherConditions.Cloudy;
+
+            // TODO tohle bylo 10_000, jak mi to má vycházet, zkusit na hourly data
+            if (lux != 0)
+                return WeatherConditions.Overcast;
+
+            return WeatherConditions.Dark;
+        }
+
+        /// <summary>
+        /// Weather conditions to average lux
+        /// </summary>
+        /// <param name="condition">Weather conditions</param>
+        /// <returns>Lux value</returns>
+        internal static double TransferConditionsToLux(WeatherConditions condition)
+        {
+            if (condition == WeatherConditions.Sunny)
+                return 60_000;
+
+            if (condition == WeatherConditions.Cloudy)
+                return 30_000;
+
+            if (condition == WeatherConditions.Overcast)
+                return 10_000;
+
+            if (condition == WeatherConditions.Dark)
+                return 0;
+
+            return -1;
+        }
+
+        /// <summary>
+        /// Cloud cover value in percentage to weather conditions
+        /// </summary>
+        /// <param name="cloudCover">Value expected between 0-100</param>
+        /// <returns>WeatherConditions</returns>
+        internal static WeatherConditions CloudCoverToConditions(int cloudCover)
+        {
+            if (cloudCover >= 66)
+                return WeatherConditions.Overcast;
+
+            if (cloudCover >= 33)
+                return WeatherConditions.Cloudy;
+
+            if (cloudCover >= 0)
+                return WeatherConditions.Sunny;
+
+            return WeatherConditions.Dark;
+        }
+    }
+}
\ No newline at end of file
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/ValueToConditions.cs.meta b/Client/Client/Assets/Scripts/Weather/Parser/ValueToConditions.cs.meta
new file mode 100644
index 0000000..888a3cd
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/ValueToConditions.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 512dca1c9c5043748998e4c57471d216
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs b/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs
new file mode 100644
index 0000000..6c8b760
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs
@@ -0,0 +1,15 @@
+﻿//
+// Author: A. Konig
+//
+
+namespace ServerApp.Parser.OutputInfo
+{
+    /// <summary>
+    /// Weather conditions in regards to sun level
+    /// </summary>
+    /// <author>A. Konig</author>
+    public enum WeatherConditions
+    {
+        Sunny, Cloudy, Overcast, Dark
+    }
+}
\ No newline at end of file
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs.meta b/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs.meta
new file mode 100644
index 0000000..8575cf2
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/WeatherConditions.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: a5eceb3b3d9e35944ae9c3a57105ee77
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/WeatherInfo.cs b/Client/Client/Assets/Scripts/Weather/Parser/WeatherInfo.cs
new file mode 100644
index 0000000..52d70cd
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/WeatherInfo.cs
@@ -0,0 +1,89 @@
+﻿//
+// Author: A. Konig
+//
+
+using System;
+
+namespace ServerApp.Parser.OutputInfo
+{
+    /// <summary>
+    /// Class representing the weather in a given interval at ZCU
+    /// - shortest possible interval is 1h
+    /// </summary>
+    /// <author>A. Konig</author>
+    class WeatherInfo
+    {
+        /// <summary> Temperature in °C </summary>
+        public double temp;
+        /// <summary> Probability of rain in % </summary>
+        public int rain;
+        /// <summary> Wind in m/s </summary>
+        public double wind;
+        /// <summary> Luminance </summary>
+        public double lum;
+        /// <summary> General weather conditions </summary>
+        public WeatherConditions condition;
+
+        /// <summary> Start of interval </summary>
+        public DateTime startTime;
+        /// <summary> Length of interval in hours </summary>
+        public int intervalLength;
+
+        public WeatherInfo()
+        {
+            condition = WeatherConditions.Dark;
+        }
+
+        /// <summary>
+        /// Constructor
+        /// </summary>
+        /// <param name="startTime">Start of the interval</param>
+        /// <param name="temp">Temperature in °C</param>
+        /// <param name="rain">Probability of rain in %</param>
+        /// <param name="wind">Wind in m/w</param>
+        /// <param name="lum">Luminance in lux</param>
+        /// <param name="intervalLength">Interval length</param>
+        public WeatherInfo(DateTime startTime, double temp, int rain, double wind, double lum, int intervalLength)
+        {
+            this.startTime = startTime;
+            this.temp = temp;
+            this.rain = rain;
+            this.wind = wind;
+            this.lum = lum;
+            this.intervalLength = intervalLength;
+
+            condition = ValueToConditions.TransferLuxToConditions(lum);
+        }
+
+        /// <summary>
+        /// Constructor
+        /// </summary>
+        /// <param name="startTime">Start of the interval</param>
+        /// <param name="temp">Temperature in °C</param>
+        /// <param name="rain">Probability of rain in %</param>
+        /// <param name="wind">Wind in m/s</param>
+        /// <param name="condition">Weather conditions</param>
+        /// <param name="intervalLength">Interval length</param>
+        public WeatherInfo(DateTime startTime, double temp, int rain, double wind, WeatherConditions condition, int intervalLength)
+        {
+            this.startTime = startTime;
+            this.temp = temp;
+            this.rain = rain;
+            this.wind = wind;
+            this.condition = condition;
+            this.intervalLength = intervalLength;
+
+            lum = ValueToConditions.TransferConditionsToLux(condition);
+        }
+
+        /// <summary>
+        /// To string
+        /// </summary>
+        /// <returns>interval start temperature probability of rain wind    weather condition</returns>
+        public override string ToString()
+        {
+            return $"{startTime} \t {temp}°C \t {rain}% \t {wind}m/s \t {condition.ToString()} \t {lum}";
+        }
+
+    }
+}
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/WeatherInfo.cs.meta b/Client/Client/Assets/Scripts/Weather/Parser/WeatherInfo.cs.meta
new file mode 100644
index 0000000..71294a0
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/WeatherInfo.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 8051d4ecceaf87b4eb704c614992494e
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherData.cs b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
index 74ecef5..21e2c28 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherData.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
@@ -1,4 +1,5 @@
-﻿using System.Collections;
+﻿using ServerApp.Parser.OutputInfo;
+using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
 
@@ -9,9 +10,9 @@ public class WeatherData
     public double Temperature { get; private set; }
     public double Wind { get; private set; }
     public double Rain { get; private set; }
-    public WeatherCondition Weather { get; private set; }
+    public WeatherConditions Weather { get; private set; }
 
-    public void SetValues(double temperature, double wind, double rain, WeatherCondition weather)
+    public void SetValues(double temperature, double wind, double rain, WeatherConditions weather)
     {
         Temperature = temperature;
         Wind = wind;
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
index 76d9e97..b292449 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
@@ -1,4 +1,6 @@
-﻿using System.Collections;
+﻿using ServerApp.Parser.OutputInfo;
+using System;
+using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
 using UnityEngine.UI;
@@ -13,6 +15,8 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
     public Text rainText;
     public Text windText;
 
+    public bool useOwnWeather = false;
+
     void Start()
     {
         data = new WeatherData();
@@ -26,16 +30,16 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
     {
         switch (data.Weather)
         {
-            case WeatherCondition.Sunny:
+            case WeatherConditions.Sunny:
                 weatherText.text = "SUNNY";
                 break;
-            case WeatherCondition.Cloudy:
+            case WeatherConditions.Cloudy:
                 weatherText.text = "CLOUDY";
                 break;
-            case WeatherCondition.Overcast:
+            case WeatherConditions.Overcast:
                 weatherText.text = "OVERCAST";
                 break;
-            case WeatherCondition.Dark:
+            case WeatherConditions.Dark:
                 weatherText.text = "DARK";
                 break;
         }
@@ -45,6 +49,18 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
         windText.text = $"WIND {(int)Mathf.Round((float)data.Wind)} M/S";
     }
 
+    public void SetWeather(Request request)
+    {
+        request.useWeather = useOwnWeather;
+        if (useOwnWeather)
+        {
+            request.rain = data.Rain;
+            request.wind = data.Wind;
+            request.weather = data.Weather;
+            request.temperature = data.Temperature;
+        }
+    }
+
     public void Clear()
     {
         provider = new WeatherProvider(data);
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs b/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
index 1b1d332..b3d00a6 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
@@ -1,4 +1,5 @@
-﻿using System.Collections;
+﻿using ServerApp.WeatherPredictionParser;
+using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
 
@@ -6,6 +7,8 @@ public class WeatherProvider
 {
     private WeatherData data;
 
+    JsonParser parser = new JsonParser("http://wttr.in/Plzen,czechia?format=j1");
+
     public WeatherProvider(WeatherData data)
     {
         this.data = data;
@@ -13,11 +16,26 @@ public class WeatherProvider
 
     public void Load()
     {
-        var temperature = Random.Range(-10f, 30f);
-        var wind = Random.Range(0f, 20f);
-        var rain = Random.Range(0f, 100f);
-        var weather = (WeatherCondition)Random.Range(0, 3);
+        //var temperature = Random.Range(-10f, 30f);
+        //var wind = Random.Range(0f, 20f);
+        //var rain = Random.Range(0f, 100f);
+        //var weather = (WeatherCondition)Random.Range(0, 3);
 
-        data.SetValues(temperature, wind, rain, weather);
+        parser.ParsePrediction();
+        var current = parser.Current;
+        
+        if (current != null)
+        {
+            var temperature = current.temp;
+            var rain = current.rain;
+            var wind = current.wind;
+            var weather = current.condition;
+            
+            data.SetValues(temperature, wind, rain, weather);
+        }
+        else
+        {
+            Debug.LogError("Error loading weather.");
+        }
     }
 }
diff --git a/Client/Client/Assets/Scripts/WebGLMapController.cs b/Client/Client/Assets/Scripts/WebGLMapController.cs
index 1c0cfad..436e17c 100644
--- a/Client/Client/Assets/Scripts/WebGLMapController.cs
+++ b/Client/Client/Assets/Scripts/WebGLMapController.cs
@@ -13,11 +13,22 @@ public class WebGLMapController : MonoBehaviour
 	[SerializeField]
 	private float zoomSpeed;
 
+	[SerializeField]
+	private float minScale = 0.5f;
+	
+	[SerializeField]
+	private float maxScale = 1f;
+
 	private Vector3 screenPoint;
 	private Vector3 offset;
 
 	private bool block;
 
+	void Update()
+	{
+		ClampPan();
+	}
+
     void OnMouseDown()
 	{
 		if (!map.interactable || block) return;
@@ -98,7 +109,7 @@ public class WebGLMapController : MonoBehaviour
 
 	private float ClampScale(float scale)
     {
-		return Mathf.Min(Mathf.Max(scale, 1f), 2.5f);
+		return Mathf.Min(Mathf.Max(scale, minScale), maxScale);
 	}
 
 	private Bounds TransformBounds(Bounds bounds)
